// AddDevice.cpp : implementation file
//

#include "stdafx.h"
#include <afxtempl.h>
#include "crobot.h"
#include "crobotinternet.h"
#include "HotOffThePress.h"
#include "DeviceIDDlg.h"
#include "SouceDlg.h"
#include "TimeTickerDlg.h"
#include "NewzDlg.h"
#include "FinancialDlg.h"
#include "AlertsDlg.h"
#include "UpdatesDlg.h"
#include "NoDeviceDlg.h"
#include "Ports.h"
#include "Device.h"
#include "DevicesDlg.h"
#include "AddDevice.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAddDevice dialog


CAddDevice::CAddDevice(CWnd* pParent /*=NULL*/)
	: CDialog(CAddDevice::IDD, pParent)
{
	//{{AFX_DATA_INIT(CAddDevice)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT

	m_dev = DT_NULLDEVICE;
}


void CAddDevice::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAddDevice)
	DDX_Control(pDX, IDOK, m_OK);
	DDX_Control(pDX, IDC_EXPLANATIONS, m_wExp);
	DDX_Control(pDX, IDC_DEVICETREE, m_DeviceTree);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CAddDevice, CDialog)
	//{{AFX_MSG_MAP(CAddDevice)
	ON_NOTIFY(TVN_SELCHANGED, IDC_DEVICETREE, OnSelchangedDevicetree)
	ON_NOTIFY(NM_DBLCLK, IDC_DEVICETREE, OnDblclkDevicetree)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAddDevice message handlers

BOOL CAddDevice::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// Fill tree with Devices
	CString str;
	HTREEITEM hItem, hRootItem;

	// Ticker items
	str.LoadString( IDS_DEVTICKERS );
	hRootItem = m_DeviceTree.InsertItem( str, TVI_ROOT, TVI_LAST );
	m_DeviceTree.SetItemData( hRootItem, (DWORD)VDT_TICKERDEVS );  // Root items are not devices
	m_DeviceTree.SelectItem( hRootItem );

	
	str.LoadString( IDS_DEVYAHOOTICKER );
	hItem = m_DeviceTree.InsertItem( str, hRootItem, TVI_LAST );
	m_DeviceTree.SetItemData( hItem, (DWORD)DT_YAHOOTICKER );  
	
	str.LoadString( IDS_DEVMSNTICKER );
	hItem = m_DeviceTree.InsertItem( str, hRootItem, TVI_LAST );
	m_DeviceTree.SetItemData( hItem, (DWORD)DT_MSNTICKER );  

	// Calendar items
	str.LoadString( IDS_TIMEDEVS );
	hRootItem = m_DeviceTree.InsertItem( str, TVI_ROOT, TVI_LAST );
	m_DeviceTree.SetItemData( hRootItem, (DWORD)VDT_TIMEDEVS );  // Root items are not devices
	
	str.LoadString( IDS_DEVTIME );
	hItem = m_DeviceTree.InsertItem( str, hRootItem, TVI_LAST );
	m_DeviceTree.SetItemData( hItem, (DWORD)DT_TIME );  
	
	str.LoadString( IDS_DEVDATE );
	hItem = m_DeviceTree.InsertItem( str, hRootItem, TVI_LAST );
	m_DeviceTree.SetItemData( hItem, (DWORD)DT_DATE );  

	str.LoadString( IDS_DEVDAY );
	hItem = m_DeviceTree.InsertItem( str, hRootItem, TVI_LAST );
	m_DeviceTree.SetItemData( hItem, (DWORD)DT_DAY );  

	str.LoadString( IDS_DEVWEEK );
	hItem = m_DeviceTree.InsertItem( str, hRootItem, TVI_LAST );
	m_DeviceTree.SetItemData( hItem, (DWORD)DT_WEEK );  

	str.LoadString( IDS_DEVYEAR );
	hItem = m_DeviceTree.InsertItem( str, hRootItem, TVI_LAST );
	m_DeviceTree.SetItemData( hItem, (DWORD)DT_YEAR );  

	str.LoadString( IDS_DEVSIDEREAL );
	hItem = m_DeviceTree.InsertItem( str, hRootItem, TVI_LAST );
	m_DeviceTree.SetItemData( hItem, (DWORD)DT_SIDEREAL );  	

	// Web Dial items
	str.LoadString( IDS_DEVWEBDIALS );
	hRootItem = m_DeviceTree.InsertItem( str, TVI_ROOT, TVI_LAST );
	m_DeviceTree.SetItemData( hRootItem, (DWORD)VDT_DEVWEBDIALS );  // Root items are not devices
	
	str.LoadString( IDS_DEVWEBNUM );
	hItem = m_DeviceTree.InsertItem( str, hRootItem, TVI_LAST );
	m_DeviceTree.SetItemData( hItem, (DWORD)DT_WEBNUMDIAL );  
	
	str.LoadString( IDS_DEVWEBTEXT );
	hItem = m_DeviceTree.InsertItem( str, hRootItem, TVI_LAST );
	m_DeviceTree.SetItemData( hItem, (DWORD)DT_WEBTEXTDIAL );  
	
	str.LoadString( IDS_DEVWEBTIME );
	hItem = m_DeviceTree.InsertItem( str, hRootItem, TVI_LAST );
	m_DeviceTree.SetItemData( hItem, (DWORD)DT_WEBTIMEDIAL );  
	
	// set focus on tree
	m_DeviceTree.SetFocus();

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CAddDevice::OnSelchangedDevicetree(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_TREEVIEW* pNMTreeView = (NM_TREEVIEW*)pNMHDR;
	CString str;

	// Identify device
	m_dev = (DeviceType) m_DeviceTree.GetItemData( m_DeviceTree.GetSelectedItem() );

	switch (m_dev)
	{
	case VDT_TICKERDEVS:
		str.LoadString( IDS_DEVTICKERSX );
		m_wExp.SetWindowText( str );
		m_OK.EnableWindow( false );
		break;
	
	case DT_YAHOOTICKER:
		str.LoadString( IDS_DEVYAHOOTICKERX );
		m_wExp.SetWindowText( str );
		m_OK.EnableWindow( true );
		break;
	
	case DT_MSNTICKER:
		str.LoadString( IDS_DEVMSNTICKERX );
		m_wExp.SetWindowText( str );
		m_OK.EnableWindow( true );
		break;

	case VDT_TIMEDEVS:
		str.LoadString( IDS_TIMEDEVSX );
		m_wExp.SetWindowText( str );
		m_OK.EnableWindow( false );
		break;
	
	case DT_TIME:
		str.LoadString( IDS_DEVTIMEX );
		m_wExp.SetWindowText( str );
		m_OK.EnableWindow( true );
		break;
	
	case DT_DATE:
		str.LoadString( IDS_DEVDATEX );
		m_wExp.SetWindowText( str );
		m_OK.EnableWindow( true );
		break;
	
	case DT_DAY:
		str.LoadString( IDS_DEVDAYX );
		m_wExp.SetWindowText( str );
		m_OK.EnableWindow( true );
		break;
	
	case DT_WEEK:
		str.LoadString( IDS_DEVWEEKX );
		m_wExp.SetWindowText( str );
		m_OK.EnableWindow( true );
		break;
	
	case DT_YEAR:
		str.LoadString( IDS_DEVYEARX );
		m_wExp.SetWindowText( str );
		m_OK.EnableWindow( true );
		break;
	
	case DT_SIDEREAL:
		str.LoadString( IDS_DEVSIDEREALX );
		m_wExp.SetWindowText( str );
		m_OK.EnableWindow( true );
		break;
	
	case VDT_DEVWEBDIALS:
		str.LoadString( IDS_DEVWEBDIALSX );
		m_wExp.SetWindowText( str );
		m_OK.EnableWindow( false );
		break;
	
	case DT_WEBNUMDIAL:
		str.LoadString( IDS_DEVWEBNUMX );
		m_wExp.SetWindowText( str );
		m_OK.EnableWindow( true );
		break;
	
	case DT_WEBTEXTDIAL:
		str.LoadString( IDS_DEVWEBTEXTX );
		m_wExp.SetWindowText( str );
		m_OK.EnableWindow( true );
		break;
	
	case DT_WEBTIMEDIAL:
		str.LoadString( IDS_DEVWEBTIMEX );
		m_wExp.SetWindowText( str );
		m_OK.EnableWindow( true );
		break;
	
	default:
		AfxMessageBox( "Switch Error in OnSelchangedDevicetree in adddevice.cpp");
		break;

	}
	
	*pResult = 0;
}

void CAddDevice::OnDblclkDevicetree(NMHDR* pNMHDR, LRESULT* pResult) 
{
	if (m_OK.IsWindowEnabled()) OnOK();	
	*pResult = 0;
}

