// AlertsDlg.cpp : implementation file
//

#include "stdafx.h"
#include <sys/types.h>
#include <sys/timeb.h>
#include <time.h>
#include <afxtempl.h>
#include "crobot.h"
#include "crobotinternet.h"
#include "HotOffThePress.h"
#include "DeviceIDDlg.h"
#include "SouceDlg.h"
#include "TimeTickerDlg.h"
#include "NewzDlg.h"
#include "FinancialDlg.h"
#include "AlertsDlg.h"
#include "UpdatesDlg.h"
#include "NoDeviceDlg.h"
#include "Device.h"
#include "AlertsDlg.h"
#include "AddAlertDlg.h"
#include "FindNumDlg.h"
#include "CalibNumDlg.h"
#include "YahooTicker.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAlertsDlg property page

IMPLEMENT_DYNCREATE(CAlertsDlg, CPropertyPage)

CAlertsDlg::CAlertsDlg() : CPropertyPage(CAlertsDlg::IDD)
{
	//{{AFX_DATA_INIT(CAlertsDlg)
	m_bLeft = FALSE;
	//}}AFX_DATA_INIT

}

CAlertsDlg::~CAlertsDlg()
{
}

void CAlertsDlg::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAlertsDlg)
	DDX_Control(pDX, IDC_REMOVE, m_btRemove);
	DDX_Control(pDX, IDC_ALERTS, m_AlertList);
	DDX_Check(pDX, IDC_LEFTFLAGS, m_bLeft);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CAlertsDlg, CPropertyPage)
	//{{AFX_MSG_MAP(CAlertsDlg)
	ON_BN_CLICKED(IDC_ADD, OnAdd)
	ON_BN_CLICKED(IDC_REMOVE, OnRemove)
	ON_LBN_DBLCLK(IDC_ALERTS, OnDblclkAlerts)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAlertsDlg message handlers

BOOL CAlertsDlg::OnKillActive() 
{
	BOOL RetVal = CPropertyPage::OnKillActive();
	
	UpdateData( true );

	// If successfully killed (i.e. validation and DDE OK), copy result to device
	if (RetVal)
	{
		// Set up ticker data
		CYahooTicker* pTicker = (CYahooTicker*) ((CHotOffThePressApp*)AfxGetApp())->m_pCurrDev;

		pTicker->m_bLeft = m_bLeft==0? false : true;
	}

	return RetVal;
}

BOOL CAlertsDlg::OnSetActive() 
{
	BOOL RetVal = CPropertyPage::OnSetActive();

	// Set up ticker data
	CYahooTicker* pTicker = (CYahooTicker*) ((CHotOffThePressApp*)AfxGetApp())->m_pCurrDev;
	m_bLeft = pTicker->m_bLeft==TRUE ? 1 : 0 ;
	UpdateData( false );
	
	return RetVal;
}


BOOL CAlertsDlg::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();
	
	// Fill list box with device list
	int i;
	CYahooTicker* pTicker = (CYahooTicker*) ((CHotOffThePressApp*)AfxGetApp())->m_pCurrDev;
	m_AlertList.ResetContent();
	for (i=0; i<pTicker->m_slAlTrigger.GetCount(); i++)
	{
		CString str = "[ " + pTicker->m_slAlTrigger.GetAt(pTicker->m_slAlTrigger.FindIndex(i)) + 
			          " ]  " + pTicker->m_slAlMessage.GetAt(pTicker->m_slAlMessage.FindIndex(i));
		m_AlertList.AddString( str );
	}

	// Check something is in list and set selection
	if (m_AlertList.GetCount()==0)
	{
		m_btRemove.EnableWindow( false );
	}
	else
	{
		m_AlertList.SetCurSel( 0 );
		m_btRemove.EnableWindow( true );
	}
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CAlertsDlg::OnAdd() 
{
	CAddAlertDlg dlg;

	dlg.m_Message = "";
	dlg.m_Trigger = "";
	dlg.m_iBeep = 0;
	dlg.m_iFlash = 0;
	dlg.m_iFlag = 0;

	if (dlg.DoModal()==IDOK)
	{
		CYahooTicker* pTicker = (CYahooTicker*) ((CHotOffThePressApp*)AfxGetApp())->m_pCurrDev;
		pTicker->m_slAlTrigger.AddTail( dlg.m_Trigger );
		pTicker->m_slAlMessage.AddTail( dlg.m_Message );
		pTicker->m_lbAlBeep.AddTail( (BeepType) dlg.m_iBeep );
		pTicker->m_lbAlFlash.AddTail( (FlashType) dlg.m_iFlash );
		pTicker->m_lbAlFlag.AddTail( dlg.m_iFlag );
		CString str = "[ " + dlg.m_Trigger + " ]  " + dlg.m_Message;
		m_AlertList.AddString( str );
		m_AlertList.SetCurSel( m_AlertList.GetCount() - 1 );
		m_btRemove.EnableWindow( true );
	}

}

void CAlertsDlg::OnRemove() 
{
	// Remove item
	CYahooTicker* pTicker = (CYahooTicker*) ((CHotOffThePressApp*)AfxGetApp())->m_pCurrDev;
	int iRem = m_AlertList.GetCurSel();
	pTicker->m_slAlTrigger.RemoveAt( pTicker->m_slAlTrigger.FindIndex( iRem ) );
	pTicker->m_slAlMessage.RemoveAt( pTicker->m_slAlMessage.FindIndex( iRem ) );
	pTicker->m_lbAlBeep.RemoveAt( pTicker->m_lbAlBeep.FindIndex( iRem ) );
	pTicker->m_lbAlFlash.RemoveAt( pTicker->m_lbAlFlash.FindIndex( iRem ) );
	pTicker->m_lbAlFlag.RemoveAt( pTicker->m_lbAlFlag.FindIndex( iRem ) );
	m_AlertList.DeleteString( iRem );

	// Update Remove button
	m_btRemove.EnableWindow( m_AlertList.GetCount()>0 );
}

void CAlertsDlg::OnDblclkAlerts() 
{
	CAddAlertDlg dlg;
	int iRem = m_AlertList.GetCurSel();

	CYahooTicker* pTicker = (CYahooTicker*) ((CHotOffThePressApp*)AfxGetApp())->m_pCurrDev;
	dlg.m_Message = pTicker->m_slAlMessage.GetAt( pTicker->m_slAlMessage.FindIndex( iRem ) );
	dlg.m_Trigger = pTicker->m_slAlTrigger.GetAt( pTicker->m_slAlTrigger.FindIndex( iRem ) );
	dlg.m_iBeep = pTicker->m_lbAlBeep.GetAt( pTicker->m_lbAlBeep.FindIndex( iRem ) );
	dlg.m_iFlash = pTicker->m_lbAlFlash.GetAt( pTicker->m_lbAlFlash.FindIndex( iRem ) );
	dlg.m_iFlag = pTicker->m_lbAlFlag.GetAt( pTicker->m_lbAlFlag.FindIndex( iRem ) );

	if (dlg.DoModal()==IDOK)
	{
		pTicker->m_slAlTrigger.SetAt( pTicker->m_slAlTrigger.FindIndex( iRem ), dlg.m_Trigger );
		pTicker->m_slAlMessage.SetAt( pTicker->m_slAlMessage.FindIndex( iRem ), dlg.m_Message );
		pTicker->m_lbAlBeep.SetAt( pTicker->m_lbAlBeep.FindIndex( iRem ), (BeepType) dlg.m_iBeep );
		pTicker->m_lbAlFlash.SetAt( pTicker->m_lbAlFlash.FindIndex( iRem ), (FlashType)dlg.m_iFlash );
		pTicker->m_lbAlFlag.SetAt( pTicker->m_lbAlFlag.FindIndex( iRem ), dlg.m_iFlag );

		// reset list box
		int i;
		m_AlertList.ResetContent();
		for (i=0; i<pTicker->m_slAlTrigger.GetCount(); i++)
		{
			CString str = "[ " + pTicker->m_slAlTrigger.GetAt(pTicker->m_slAlTrigger.FindIndex(i)) + 
						  " ]  " + pTicker->m_slAlMessage.GetAt(pTicker->m_slAlMessage.FindIndex(i));
			m_AlertList.AddString( str );
		}

		iRem = iRem==0? 0: iRem-1;
		m_AlertList.SetCurSel( iRem );

		m_btRemove.EnableWindow( true );
	}

}
