// DevicesDlg.cpp : implementation file
//

#include "stdafx.h"
#include <afxtempl.h>
#include "crobot.h"
#include "crobotinternet.h"
#include "HotOffThePress.h"
#include "DeviceIDDlg.h"
#include "SouceDlg.h"
#include "TimeTickerDlg.h"
#include "NewzDlg.h"
#include "FinancialDlg.h"
#include "AlertsDlg.h"
#include "UpdatesDlg.h"
#include "NoDeviceDlg.h"
#include "Ports.h"
#include "Device.h"
#include "DevicesDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDevicesDlg

IMPLEMENT_DYNAMIC(CDevicesDlg, CPropertySheet)

CDevicesDlg::CDevicesDlg(UINT nIDCaption, CWnd* pParentWnd, UINT iSelectPage)
	:CPropertySheet(nIDCaption, pParentWnd, iSelectPage)
{
	m_psh.dwFlags |= PSH_NOAPPLYNOW;
	EnableStackedTabs( false );

	// If Tickeronly, create ports tab. Othrwise, create Devices tab
	// Note, objects stil exist inside this class, whether or not the 
	// pages are created
	if (TICKERONLY)
	{
		// Create ports tab
		AddPage( &m_PortsDlg );
	}
	else
	{
		AddPage( &m_NoDeviceDlg );
		this->SetActivePage( &m_NoDeviceDlg );
	}

}

CDevicesDlg::CDevicesDlg(LPCTSTR pszCaption, CWnd* pParentWnd, UINT iSelectPage)
	:CPropertySheet(pszCaption, pParentWnd, iSelectPage)
{
	AddPage( &m_NoDeviceDlg );
}

CDevicesDlg::~CDevicesDlg()
{
}


BEGIN_MESSAGE_MAP(CDevicesDlg, CPropertySheet)
	//{{AFX_MSG_MAP(CDevicesDlg)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_EXITBUTT, OnExitButton)
	ON_BN_CLICKED(IDC_HELPBUTT, OnHelpButton)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDevicesDlg message handlers

BOOL CDevicesDlg::OnInitDialog() 
{
	BOOL bResult = CPropertySheet::OnInitDialog();

	m_fntDlg.CreatePointFont( 8, "MS Sans Serif" );

	// Add pages appropriate to selected device

	// Show tabs for First Device  
	CList<CDevice*, CDevice*>* Devs = &((CHotOffThePressApp*)AfxGetApp())->m_Devs;

	if (!Devs->IsEmpty())
	{
		// Get Pointer to device list
		((CHotOffThePressApp*)AfxGetApp())->m_pCurrDev = Devs->GetAt(Devs->FindIndex( 0 ));

		// Add Pages
		((CHotOffThePressApp*)AfxGetApp())->m_pCurrDev->AddPages();
	}
	else
	{
		((CHotOffThePressApp*)AfxGetApp())->m_pCurrDev = NULL;
	}

	this->

	// Ensure Devices page is on top at start
	SetActivePage( &m_NoDeviceDlg );

	// Add Exit button

#define XELOC 254
#define YELOC 55
/*
	CString ButtTit;
	ButtTit.LoadString(IDS_EXITBUTT);
	CRect rDlgRct;
	GetWindowRect(rDlgRct);
	CRect ButtPos(	(rDlgRct.right-rDlgRct.left)-XELOC, 
					(rDlgRct.bottom-rDlgRct.top)-YELOC, 
					(rDlgRct.right-rDlgRct.left)-XELOC+80, 
					(rDlgRct.bottom-rDlgRct.top)-YELOC+23 );
	m_ExitButt.Create( ButtTit, WS_VISIBLE | WS_CHILD | WS_TABSTOP |
		BS_PUSHBUTTON, ButtPos, this, IDC_EXITBUTT );
	m_ExitButt.SetFont(&m_fntDlg);
	
	
	// Add Help button

#define XHLOC 340
#define YHLOC 55

	CString HButtTit;
	HButtTit.LoadString(IDS_HELPBUTT);
	CRect HButtPos(	(rDlgRct.right-rDlgRct.left)-XHLOC, 
					(rDlgRct.bottom-rDlgRct.top)-YHLOC, 
					(rDlgRct.right-rDlgRct.left)-XHLOC+80, 
					(rDlgRct.bottom-rDlgRct.top)-YHLOC+23 );
	m_HelpButt.Create( HButtTit, WS_VISIBLE | WS_CHILD | WS_TABSTOP |
		BS_PUSHBUTTON, HButtPos, this, IDC_HELPBUTT );
	m_HelpButt.SetFont(&m_fntDlg);
*/
	return bResult;
}


void CDevicesDlg::OnExitButton() 
{
	((CHotOffThePressApp*)AfxGetApp())->m_bExiting = true;
	PressButton(PSBTN_OK);
}


void CDevicesDlg::OnHelpButton() 
{
	CString str;
	str.LoadString( IDS_HELPURL );

	ShellExecute(NULL, NULL, str, NULL, NULL, SW_SHOWNORMAL );
}


