// FinancialDlg.cpp : implementation file
//

#include "stdafx.h"
#include <sys/types.h>
#include <sys/timeb.h>
#include <time.h>
#include <afxtempl.h>
#include "crobot.h"
#include "crobotinternet.h"
#include "HotOffThePress.h"
#include "DeviceIDDlg.h"
#include "SouceDlg.h"
#include "TimeTickerDlg.h"
#include "NewzDlg.h"
#include "FinancialDlg.h"
#include "AlertsDlg.h"
#include "UpdatesDlg.h"
#include "NoDeviceDlg.h"
#include "Device.h"
#include "FinancialDlg.h"
#include "FindNumDlg.h"
#include "CalibNumDlg.h"
#include "YahooTicker.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CFinancialDlg property page

IMPLEMENT_DYNCREATE(CFinancialDlg, CPropertyPage)

CFinancialDlg::CFinancialDlg() : CPropertyPage(CFinancialDlg::IDD)
{
	//{{AFX_DATA_INIT(CFinancialDlg)
	//}}AFX_DATA_INIT
}

CFinancialDlg::~CFinancialDlg()
{
}

void CFinancialDlg::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CFinancialDlg)
	DDX_Control(pDX, IDC_MAXFINANCE, m_eMaxFinance);
	DDX_Control(pDX, IDC_FIRSTNAME, m_eFirstName);
	DDX_Control(pDX, IDC_SHOWPRICE, m_btPrice);
	DDX_Control(pDX, IDC_SHOWPERCENT, m_btPercent);
	DDX_Control(pDX, IDC_SHOWFINANCE, m_btFinance);
	DDX_Control(pDX, IDC_SHOWCHANGE, m_btChange);
	DDX_Control(pDX, IDC_NOSHOWZERO, m_btNoShowZero);
	DDX_Control(pDX, IDC_NODIGITS, m_btNoDigits);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CFinancialDlg, CPropertyPage)
	//{{AFX_MSG_MAP(CFinancialDlg)
	ON_BN_CLICKED(IDC_SHOWFINANCE, OnShowfinance)
	ON_BN_CLICKED(IDC_SHOWPERCENT, OnShowpercent)
	ON_BN_CLICKED(IDC_SHOWCHANGE, OnShowchange)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFinancialDlg message handlers

BOOL CFinancialDlg::OnKillActive() 
{
	BOOL RetVal = CPropertyPage::OnKillActive();
	
	// If successfully killed (i.e. validation and DDE OK), copy result to device
	if (RetVal)
	{
		// Set up ticker data
		CYahooTicker* pTicker = (CYahooTicker*) ((CHotOffThePressApp*)AfxGetApp())->m_pCurrDev;
		pTicker->m_bFinancial = m_btFinance.GetCheck()? true: false;
		pTicker->m_bPrice = m_btPrice.GetCheck()? true: false;
		pTicker->m_bChange = m_btChange.GetCheck()? true: false;
		pTicker->m_bPercent = m_btPercent.GetCheck()? true: false;
		pTicker->m_bOmitDigits = m_btNoDigits.GetCheck()? true: false;
		pTicker->m_bNoZeroChange = m_btNoShowZero.GetCheck()? true: false;
		m_eFirstName.GetWindowText( pTicker->m_strFirstLine );

		// Validate m_iNumLine
		CString sMaxNum;
		m_eMaxFinance.GetWindowText(sMaxNum);
		long iMaxNum = 0;
		sscanf( sMaxNum, "%ld", (long*) &iMaxNum );
		if ((iMaxNum<1 || iMaxNum >1000) && pTicker->m_bFinancial!=0)
		{
			AfxMessageBox(IDS_MAXFINLIMIT, MB_OK );
			return false;
		}
		pTicker->m_iNumLine = (int) iMaxNum;	
	}

	return RetVal;
}

BOOL CFinancialDlg::OnSetActive() 
{
	BOOL RetVal = CPropertyPage::OnSetActive();
	
	// Set up ticker data
	CYahooTicker* pTicker = (CYahooTicker*) ((CHotOffThePressApp*)AfxGetApp())->m_pCurrDev;
	m_btFinance.SetCheck( pTicker->m_bFinancial? 1 : 0);
	m_btPrice.SetCheck( pTicker->m_bPrice? 1 : 0);
	m_btChange.SetCheck( pTicker->m_bChange? 1 : 0);
	m_btPercent.SetCheck( pTicker->m_bPercent? 1 : 0);
	m_btNoDigits.SetCheck( pTicker->m_bOmitDigits? 1 : 0);
	m_btNoShowZero.SetCheck( pTicker->m_bNoZeroChange? 1 : 0);
	CString sMaxFin;
	sMaxFin.Format("%ld", (long) pTicker->m_iNumLine );
	m_eMaxFinance.SetWindowText( sMaxFin );
	m_eFirstName.SetWindowText( pTicker->m_strFirstLine );

	// Enable as necessary
	m_btPrice.EnableWindow( pTicker->m_bFinancial );
	m_btChange.EnableWindow( pTicker->m_bFinancial );
	m_btPercent.EnableWindow( pTicker->m_bFinancial );
	m_btNoShowZero.EnableWindow( pTicker->m_bFinancial && 
		(pTicker->m_bChange || pTicker->m_bPercent ));
	m_btNoDigits.EnableWindow( pTicker->m_bFinancial );
	m_eFirstName.EnableWindow( pTicker->m_bFinancial );
	m_eMaxFinance.EnableWindow( pTicker->m_bFinancial );
	
	this->UpdateData( false );
	
	return RetVal;
}

void CFinancialDlg::OnShowfinance() 
{
	// Enable as necessary
	CYahooTicker* pTicker = (CYahooTicker*) ((CHotOffThePressApp*)AfxGetApp())->m_pCurrDev;
	m_btPrice.EnableWindow( m_btFinance.GetCheck()?true:false );
	m_btChange.EnableWindow( m_btFinance.GetCheck()?true:false );
	m_btPercent.EnableWindow( m_btFinance.GetCheck()?true:false );
	m_btNoDigits.EnableWindow( m_btFinance.GetCheck()?true:false );
	m_btNoShowZero.EnableWindow( (m_btFinance.GetCheck()?true:false) && 
		(m_btChange.GetCheck()?true:false || m_btPercent.GetCheck()?true:false) );
	m_eFirstName.EnableWindow( m_btFinance.GetCheck()?true:false );
	m_eMaxFinance.EnableWindow( m_btFinance.GetCheck()?true:false );
}

void CFinancialDlg::OnShowpercent() 
{
	// Enable as necessary	
	OnShowfinance() ;
}


void CFinancialDlg::OnShowchange() 
{
	// Enable as necessary	
	OnShowfinance() ;
}
