// FindNumDlg.cpp : implementation file
//

#include "stdafx.h"
#include <sys/types.h>
#include <sys/timeb.h>
#include <time.h>
#include <afxtempl.h>
#include "crobot.h"
#include "crobotinternet.h"
#include "HotOffThePress.h"
#include "UpdatesDlg.h"
#include "DeviceIDDlg.h"
#include "SouceDlg.h"
#include "Device.h"
#include "DownloadDlg.h"
#include "FindNumDlg.h"
#include "CalibNumDlg.h"
#include "AlignDlg.h"
#include "Keywords.h"
#include "FindText.h"
#include "WebTextDial.h"
#include "WebNumDial.h"


#include "TimeTickerDlg.h"
#include "NewzDlg.h"
#include "FinancialDlg.h"
#include "AlertsDlg.h"
#include "UpdatesDlg.h"
#include "NoDeviceDlg.h"
#include "Device.h"
#include "NewzDlg.h"
#include "FindNumDlg.h"
#include "CalibNumDlg.h"

#include "YahooTicker.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CFindNumDlg property page

IMPLEMENT_DYNCREATE(CFindNumDlg, CPropertyPage)

CFindNumDlg::CFindNumDlg() : CPropertyPage(CFindNumDlg::IDD)
, m_TestResult(_T(""))
{
	//{{AFX_DATA_INIT(CFindNumDlg)
	m_bCalcPercent = FALSE;
	m_sTriggerText = _T("");
	//}}AFX_DATA_INIT
}

CFindNumDlg::~CFindNumDlg()
{
}

void CFindNumDlg::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CFindNumDlg)
	DDX_Control(pDX, IDC_AFTERBEFORE, m_AftBef);
	DDX_Control(pDX, IDC_NUMCOUNT, m_NumCount);
	DDX_Check(pDX, IDC_HTMLOK, m_bCalcPercent);
	DDX_Text(pDX, IDC_TRIGGERTEXT, m_sTriggerText);
	//}}AFX_DATA_MAP
	DDX_Text(pDX, IDC_STATICTEST, m_TestResult);
}


BEGIN_MESSAGE_MAP(CFindNumDlg, CPropertyPage)
	//{{AFX_MSG_MAP(CFindNumDlg)
		// NOTE: the ClassWizard will add message map macros here
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_BUTTON1, OnBnClickedButton1)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFindNumDlg message handlers

void CFindNumDlg::GetData() 
{
	// Set up data
	UpdateData( true );
	CYahooTicker* pDev = (CYahooTicker*) ((CHotOffThePressApp*)AfxGetApp())->m_pCurrDev;
	pDev->m_bCalcPercent = m_bCalcPercent ? true : false;
	pDev->m_sTriggerText = m_sTriggerText;

	pDev->m_bBefore = m_AftBef.GetCurSel( ) ? true : false;
	pDev->m_iNumCount = m_NumCount.GetCurSel( ) + 1;
} 


BOOL CFindNumDlg::OnKillActive() 
{
	BOOL RetVal = CPropertyPage::OnKillActive();
	
	// If successfully killed (i.e. validation and DDE OK), copy result to device
	if (RetVal) GetData();

	return RetVal;
}

BOOL CFindNumDlg::OnSetActive() 
{
	BOOL RetVal = CPropertyPage::OnSetActive();
	
	// Set up data
	CYahooTicker* pDev = (CYahooTicker*) ((CHotOffThePressApp*)AfxGetApp())->m_pCurrDev;
	m_bCalcPercent = pDev->m_bCalcPercent;
	m_sTriggerText = pDev->m_sTriggerText;
	
	UpdateData( false );

	m_AftBef.SetCurSel( pDev->m_bBefore? 1:0 );
	m_NumCount.SetCurSel( pDev->m_iNumCount-1 );
	
	return RetVal;
}
 
void CFindNumDlg::OnBnClickedButton1()
{
	CWaitCursor cw;
	GetData();
	CYahooTicker* pDev = (CYahooTicker*) ((CHotOffThePressApp*)AfxGetApp())->m_pCurrDev;
	pDev->UpdateNow();
	m_TestResult = pDev->m_ResultText;
	UpdateData( false );
}
