// FindText.cpp : implementation file
//

#include "stdafx.h"
#include <afxtempl.h>
#include "crobot.h"
#include "crobotinternet.h"
#include "HotOffThePress.h"
#include "UpdatesDlg.h"
#include "DeviceIDDlg.h"
#include "SouceDlg.h"
#include "Device.h"
#include "DownloadDlg.h"
#include "Keywords.h"
#include "CalibNumDlg.h"
#include "AlignDlg.h"
#include "FindText.h"
#include "WebTextDial.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CFindText property page

IMPLEMENT_DYNCREATE(CFindText, CPropertyPage)

CFindText::CFindText() : CPropertyPage(CFindText::IDD)
{
	//{{AFX_DATA_INIT(CFindText)
	m_bCalcPercent = FALSE;
	m_sTriggerText = _T("");
	//}}AFX_DATA_INIT
}

CFindText::~CFindText()
{
}

void CFindText::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CFindText)
	DDX_Control(pDX, IDC_NUMCOUNT, m_NumCount);
	DDX_Control(pDX, IDC_AFTERBEFORE, m_AftBef);
	DDX_Check(pDX, IDC_HTMLOK, m_bCalcPercent);
	DDX_Text(pDX, IDC_TRIGGERTEXT, m_sTriggerText);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CFindText, CPropertyPage)
	//{{AFX_MSG_MAP(CFindText)
		// NOTE: the ClassWizard will add message map macros here
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFindText message handlers

BOOL CFindText::OnKillActive() 
{
	BOOL RetVal = CPropertyPage::OnKillActive();
	
	// If successfully killed (i.e. validation and DDE OK), copy result to device
	if (RetVal)
	{
		// Set up data
		CWebTextDial* pDev = (CWebTextDial*) ((CHotOffThePressApp*)AfxGetApp())->m_pCurrDev;
		pDev->m_bCalcPercent = m_bCalcPercent;
		pDev->m_sTriggerText = m_sTriggerText;

		pDev->m_bBefore = m_AftBef.GetCurSel( ) ? true : false;
		pDev->m_iNumCount = m_NumCount.GetCurSel( ) + 1;
	}

	return RetVal;
}

BOOL CFindText::OnSetActive() 
{
	BOOL RetVal = CPropertyPage::OnSetActive();
	
	// Set up data
	CWebTextDial* pDev = (CWebTextDial*) ((CHotOffThePressApp*)AfxGetApp())->m_pCurrDev;
	m_bCalcPercent = pDev->m_bCalcPercent;
	m_sTriggerText = pDev->m_sTriggerText;
	
	UpdateData( false );

	m_AftBef.SetCurSel( pDev->m_bBefore? 1:0 );
	m_NumCount.SetCurSel( pDev->m_iNumCount-1 );
	
	return RetVal;
}
