// NewzDlg.cpp : implementation file
//

#include "stdafx.h"
#include <sys/types.h>
#include <sys/timeb.h>
#include <time.h>
#include <afxtempl.h>
#include "crobot.h"
#include "crobotinternet.h"
#include "HotOffThePress.h"
#include "DeviceIDDlg.h"
#include "SouceDlg.h"
#include "TimeTickerDlg.h"
#include "NewzDlg.h"
#include "FinancialDlg.h"
#include "AlertsDlg.h"
#include "UpdatesDlg.h"
#include "NoDeviceDlg.h"
#include "Device.h"
#include "NewzDlg.h"
#include "FindNumDlg.h"
#include "CalibNumDlg.h"
#include "YahooTicker.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CNewzDlg property page

IMPLEMENT_DYNCREATE(CNewzDlg, CPropertyPage)

CNewzDlg::CNewzDlg() : CPropertyPage(CNewzDlg::IDD)
{
	//{{AFX_DATA_INIT(CNewzDlg)
	m_bNews = FALSE;
	m_bWeather = FALSE;
	//}}AFX_DATA_INIT
}

CNewzDlg::~CNewzDlg()
{
}

void CNewzDlg::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CNewzDlg)
	DDX_Control(pDX, IDC_HAXNEADCHECK, m_btMaxHead);
	DDX_Control(pDX, IDC_MAXHEADEDIT, m_eMaxHead);
	DDX_Check(pDX, IDC_SHOWNEWS, m_bNews);
	DDX_Check(pDX, IDC_SHOWWEATHER, m_bWeather);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CNewzDlg, CPropertyPage)
	//{{AFX_MSG_MAP(CNewzDlg)
	ON_BN_CLICKED(IDC_HAXNEADCHECK, OnMaxheadcheck)
	ON_BN_CLICKED(IDC_SHOWNEWS, OnShownews)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CNewzDlg message handlers

BOOL CNewzDlg::OnSetActive() 
{
	BOOL RetVal = CPropertyPage::OnSetActive();
	
	// Set up ticker data
	CYahooTicker* pTicker = (CYahooTicker*) ((CHotOffThePressApp*)AfxGetApp())->m_pCurrDev;
	m_btMaxHead.SetCheck( pTicker->m_bMaxHead? 1 : 0 );
	m_bNews = pTicker->m_bHeadlines;
	m_bWeather = pTicker->m_bWeather;
	CString sMaxVal;
	sMaxVal.Format( "%ld", (long)pTicker->m_iMaxHead );
	m_eMaxHead.SetWindowText( sMaxVal ) ;
	
	this->UpdateData( false );

	// Set enablement of edit box
	m_btMaxHead.EnableWindow( m_bNews );		
	m_eMaxHead.EnableWindow( pTicker->m_bMaxHead && m_bNews );		
	
	return RetVal;
}

BOOL CNewzDlg::OnKillActive() 
{
	BOOL RetVal = CPropertyPage::OnKillActive();
	
	// If successfully killed (i.e. validation and DDE OK), copy result to device
	if (RetVal)
	{
		CYahooTicker* pTicker = (CYahooTicker*) ((CHotOffThePressApp*)AfxGetApp())->m_pCurrDev;

		// Validate data -  no need
		CString sMaxVal;
		pTicker->m_bMaxHead = m_btMaxHead.GetCheck()>0;
		m_eMaxHead.GetWindowText(sMaxVal);
		long iMaxVal = 0;
		sscanf( sMaxVal, "%ld", (long*) &iMaxVal );
		if ((iMaxVal<1 || iMaxVal >1000) && pTicker->m_bMaxHead)
		{
			AfxMessageBox(IDS_MAXHEADLIMIT, MB_OK );
			return false;
		}

		// Set up ticker data
		pTicker->m_bHeadlines = (m_bNews==0) ? false : true;
		pTicker->m_bWeather = (m_bWeather==0) ? false : true;
		pTicker->m_iMaxHead = (int) iMaxVal;
	}

	return RetVal;
}

void CNewzDlg::OnMaxheadcheck() 
{
	this->UpdateData( true );

	CYahooTicker* pTicker = (CYahooTicker*) ((CHotOffThePressApp*)AfxGetApp())->m_pCurrDev;
	pTicker->m_bMaxHead = m_btMaxHead.GetCheck()>0;
	m_eMaxHead.EnableWindow( pTicker->m_bMaxHead );	
}

void CNewzDlg::OnShownews() 
{
	this->UpdateData( true );

	CYahooTicker* pTicker = (CYahooTicker*) ((CHotOffThePressApp*)AfxGetApp())->m_pCurrDev;
	pTicker->m_bMaxHead = m_btMaxHead.GetCheck()>0;
	m_btMaxHead.EnableWindow( m_bNews );		
	m_eMaxHead.EnableWindow( pTicker->m_bMaxHead && m_bNews );		
}
