// Ports.cpp : implementation file
//

#include "stdafx.h"
#include <sys/types.h>
#include <sys/timeb.h>
#include <time.h>
#include <afxtempl.h>
#include "crobot.h"
#include "crobotinternet.h"
#include "HotOffThePress.h"
#include "DeviceIDDlg.h"
#include "SouceDlg.h"
#include "TimeTickerDlg.h"
#include "NewzDlg.h"
#include "FinancialDlg.h"
#include "AlertsDlg.h"
#include "UpdatesDlg.h"
#include "NoDeviceDlg.h"
#include "Device.h"
#include "Ports.h"
#include "FindNumDlg.h"
#include "CalibNumDlg.h"
#include "YahooTicker.h"
#include <Winspool.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPorts property page

IMPLEMENT_DYNCREATE(CPorts, CPropertyPage)

CPorts::CPorts() : CPropertyPage(CPorts::IDD)
{
	//{{AFX_DATA_INIT(CPorts)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}

CPorts::~CPorts()
{
}

void CPorts::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPorts)
	DDX_Control(pDX, IDC_PORT, m_lbPorts);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CPorts, CPropertyPage)
	//{{AFX_MSG_MAP(CPorts)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPorts message handlers

BOOL CPorts::OnKillActive() 
{
	// Determine which port was selected; extract number from text
	CString strSel;
	if (m_lbPorts.GetCurSel()>=0)
	{
		m_lbPorts.GetText( m_lbPorts.GetCurSel(), strSel );
		long lCom = 0;
		if (strSel.FindOneOf(_T("123456789"))>0 )
		{
			sscanf( strSel.Mid( strSel.FindOneOf(_T("123456789")) ), "%ld" , &lCom );
		}

		// Set up new port
		if (lCom!=m_ComOnSetActive)
		{
			CHotOffThePressApp* pApp = (CHotOffThePressApp*)AfxGetApp();
			pApp->ClosePort();
			pApp->m_iComPort = (int) lCom;
			pApp->OpenPort();
		}
	}
	
	return CPropertyPage::OnKillActive();
}

BOOL CPorts::OnSetActive() 
{
	CWaitCursor cw;

	BOOL RetVal = CPropertyPage::OnSetActive();

	// Set up list box
	m_lbPorts.ResetContent();
	CString strTemp;

	// No port assigned
	strTemp.LoadString(IDS_NOCOM);		
	m_lbPorts.AddString(strTemp);
	m_lbPorts.SetCurSel(0);

	// enum remaining ports
	int i;
	// pointer to port info struct
	PPORT_INFO_2 pInfo = NULL;
	// how many bytes needed to hold all port info
	DWORD dwNeeded = 0;
	// how many bytes filled after info is gotten
	DWORD dwReturned = 0;

	int NumItem = 1;

	// Find out how much space is needed for pInfo
	EnumPorts(NULL, 2, (LPBYTE)pInfo, 0, &dwNeeded, &dwReturned);

	CHotOffThePressApp* pApp = (CHotOffThePressApp*)AfxGetApp();

	// allocate space for the port info
	pInfo = (PPORT_INFO_2)malloc(dwNeeded);
	if (pInfo == NULL) 
	{
		// handle error...
	}
	else 
	{
		EnumPorts (NULL, 2, (LPBYTE)pInfo, dwNeeded, &dwNeeded, &dwReturned);

		// loop through all the ports returned looking
		// for the type we want
		for (i = 0; i < (int)dwReturned; i++) 
		{
			// We found a port!
			// If it is a serial port, its name is COMx
			if (strncmp(pInfo[i].pPortName, "COM", 3) == 0)
			{
				int ComChan = -1;
				sscanf( &pInfo[i].pPortName[3], "%ld", &ComChan );
				if (ComChan>0)
				{
					strTemp.Format(IDS_CANOPENCOM,(long) ComChan);
					m_lbPorts.AddString(strTemp);
					if (pApp->m_iComPort == ComChan) 
					{
						m_lbPorts.SetCurSel(m_lbPorts.GetCount()-1);
					}
				}
			}
		}
	}

	// free space allocated for port info
	free(pInfo);
	pInfo = NULL;
	
	// Set up ticker data
	m_ComOnSetActive = ((CHotOffThePressApp*)AfxGetApp())->m_iComPort;

	this->UpdateData( false );
	
	return RetVal;
}
