// DeviceIDDlg.cpp : implementation file
//

#include "stdafx.h"
#include <sys/types.h>
#include <sys/timeb.h>
#include <time.h>
#include <afxtempl.h>
#include "crobot.h"
#include "crobotinternet.h"
#include "HotOffThePress.h"
#include "DeviceIDDlg.h"
#include "SouceDlg.h"
#include "TimeTickerDlg.h"
#include "NewzDlg.h"
#include "FinancialDlg.h"
#include "AlertsDlg.h"
#include "UpdatesDlg.h"
#include "NoDeviceDlg.h"
#include "Device.h"
#include "YahooTicker.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDeviceIDDlg property page

IMPLEMENT_DYNCREATE(CDeviceIDDlg, CPropertyPage)

CDeviceIDDlg::CDeviceIDDlg() : CPropertyPage(CDeviceIDDlg::IDD)
{
	//{{AFX_DATA_INIT(CDeviceIDDlg)
	m_ID = _T("");
	m_URL = _T("");
	//}}AFX_DATA_INIT
}

CDeviceIDDlg::~CDeviceIDDlg()
{
}

void CDeviceIDDlg::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDeviceIDDlg)
	DDX_Text(pDX, IDC_TICKERID, m_ID);
	DDV_MaxChars(pDX, m_ID, 19);
	DDX_Text(pDX, IDC_TICKERURL, m_URL);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDeviceIDDlg, CPropertyPage)
	//{{AFX_MSG_MAP(CDeviceIDDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDeviceIDDlg message handlers


BOOL CDeviceIDDlg::OnSetActive() 
{
	BOOL RetVal = CPropertyPage::OnSetActive();
	
	// Set up  data
	CDevice* pTicker = (CDevice*) ((CHotOffThePressApp*)AfxGetApp())->m_pCurrDev;
	m_ID = pTicker->m_strDeviceID;
	m_URL = pTicker->m_DeviceName;
	
	this->UpdateData( false );
	
	return RetVal;
}

BOOL CDeviceIDDlg::OnKillActive() 
{
	BOOL RetVal = CPropertyPage::OnKillActive();
	
	// If successfully killed (i.e. validation and DDE OK), copy result to device
	if (RetVal)
	{
		// Validate data
		// Remove spaces and hyphens from ID string
		CString sTempID( m_ID );
		sTempID.Remove(' ');
		sTempID.Remove('-');
		if (sTempID.GetLength()!=16)
		{
			AfxMessageBox(IDS_16DIGIT1234, MB_OK );
			return false;
		}
		for (int i=0; i<16 ;i++)
		{
			if ( sTempID[i]!='1' && sTempID[i]!='2' && sTempID[i]!='3' && sTempID[i]!='4' )
			{
				AfxMessageBox(IDS_16DIGIT1234, MB_OK );
				return false;
			}
		}

		// Set up  data
		CDevice* pTicker = (CDevice*) ((CHotOffThePressApp*)AfxGetApp())->m_pCurrDev;
		pTicker->m_strDeviceID = m_ID;
		pTicker->m_DeviceName = m_URL;

		int iByte = 0;
		for ( i=0; i<4; i++)
		{
			iByte = (sTempID[i*4] - '1') * 64 +
					(sTempID[i*4+1] - '1') * 16 +
					(sTempID[i*4+2] - '1') * 4 +
					(sTempID[i*4+3] - '1') ;
			pTicker->m_chid[i] = (char)iByte;
		}
	}

	return RetVal;
}
