// YahooTicker.h: interface for the CYahooTicker (public CDevice) class.
//
//////////////////////////////////////////////////////////////////////

enum FlashType {
	FT_NONE,
	FT_RED,
	FT_YELLOW,
	FT_GREEN
};

enum BeepType {
	BeepType_NONE,
	BeepType_LOW,
	BeepType_MEDIUM,
	BeepType_HIGH,
	BeepType_RLOW,
	BeepType_RMEDIUM,
	BeepType_RHIGH
};

class CYahooTicker : public CDevice
{
DECLARE_SERIAL( CYahooTicker );

public:
	CYahooTicker();
	CYahooTicker( CYahooTicker& yt);
	virtual ~CYahooTicker();
	void AddPages( );
	void RemovePages( );
	void UpdateNow();
	void ParseWebPage( CString& sTicker, CString& sDoc, int RetVal, CString& sErr );
	void ProcessHtml( CString& Str );
	void GetNextToken( CString& Str, int Pos, CString& sTemp);
	virtual void Serialize(CArchive &ar);
	void WebUpdate();
	void TransmitMessage();

	// Property Sheets
	CDeviceIDDlg m_DeviceIDDlg;
	CSouceDlg m_SourceDlg;
	CTimeTickerDlg m_TimeTickerDlg;
	CNewzDlg m_NewsDlg;
	CFinancialDlg m_FinancialDlg;
	CAlertsDlg m_AlertsDlg;
	CUpdatesDlg m_UpdatesDlg;
	CFindNumDlg m_FindNum;
	CCalibNumDlg m_CalibNum;

	// Properties
	BOOL m_bTime;
	CString m_TimeFormatString;
	BOOL m_bHeadlines;
	BOOL m_bMaxHead;
	int m_iMaxHead;
	BOOL m_bWeather;
	BOOL m_bFinancial;
	BOOL m_bPrice;
	BOOL m_bChange;
	BOOL m_bPercent;
	BOOL m_bNoZeroChange;
	BOOL m_bOmitDigits;
	CString m_strFirstLine;
	int m_iNumLine;
	CStringList m_slAlTrigger;
	CStringList m_slAlMessage;
	CList<FlashType, FlashType> m_lbAlFlash;
	CList<BeepType, BeepType> m_lbAlBeep;
	CList<int, int> m_lbAlFlag;
	BOOL m_bLeft;
	int m_ScrollRate;		// In tenths of seconds
	char m_cflags;

	CString m_TickerText;
	CTime m_LastWebUpdate;
	bool m_bTickerTextDataGood; 
	_timeb m_LastTransmission;	// time of last transmission

	// Things to transmit to ticker
//	CString m_strTickerCopy;
//	int m_iTickerCopyPos;
	BeepType m_OldBeep;
	int m_BeepMin;
	BeepType m_Beep;
	FlashType m_Flash;
	BOOL m_bLostSignal;
	CString m_TextTkrCopy;
	long m_NextTextPos;
	char m_Line[100];
	bool m_bCalcPercent;
	CString m_sTriggerText;
	bool m_bBefore;
	int m_iNumCount;

	double m_HiVal;
	int m_HiDeg;
	int m_LoDeg;
	double m_LoVal;

};

